org.springframework.context.annotation

## Enum ScopedProxyMode

- java.lang.Object
- - java.lang.Enum<ScopedProxyMode>
  - - org.springframework.context.annotation.ScopedProxyMode

All Implemented Interfaces:
  Serializable, Comparable<ScopedProxyMode>

    public enum ScopedProxyMode
    extends Enum<ScopedProxyMode>

Enumerates the various scoped-proxy options.

For a fuller discussion of exactly what a scoped-proxy is, see that section of the Spring reference documentation entitled 'Scoped beans as dependencies'.

Since:
  2.5
Author:
  Mark Fisher
See Also:
  `ScopeMetadata`

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`DEFAULT` Default typically equals `NO`, unless a different default has been configured at the component-scan instruction level.
`INTERFACES` Create a JDK dynamic proxy implementing all interfaces exposed by the class of the target object.
`NO` Do not create a scoped proxy.
`TARGET_CLASS` Create a class-based proxy (requires CGLIB).

### Method Summary

Methods
`static ScopedProxyMode` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static ScopedProxyMode[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### DEFAULT

    public static final ScopedProxyMode DEFAULT

Default typically equals `NO`, unless a different default has been configured at the component-scan instruction level.

#### NO

    public static final ScopedProxyMode NO

Do not create a scoped proxy.

This proxy-mode is not typically useful when used with a non-singleton scoped instance, which should favor the use of the `INTERFACES` or `TARGET_CLASS` proxy-modes instead if it is to be used as a dependency.

#### INTERFACES

    public static final ScopedProxyMode INTERFACES

Create a JDK dynamic proxy implementing all interfaces exposed by the class of the target object.

#### TARGET_CLASS

    public static final ScopedProxyMode TARGET_CLASS

Create a class-based proxy (requires CGLIB).

### Method Detail

#### values

    public static ScopedProxyMode[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (ScopedProxyMode c : ScopedProxyMode.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static ScopedProxyMode valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null